function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var toolkit = require('@reduxjs/toolkit');
var reactRedux = require('react-redux');
var Navbar = _interopDefault(require('react-bootstrap/Navbar'));
var Container = _interopDefault(require('react-bootstrap/Container'));
var Nav = _interopDefault(require('react-bootstrap/Nav'));

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

var configSlice = toolkit.createSlice({
  name: 'config',
  initialState: {
    cmpPositions: {}
  },
  reducers: {
    setComptPositions: function setComptPositions(state, action) {
      state.cmpPositions = _extends({}, state.cmpPositions, action.payload);
    }
  }
});
var setComptPositions = configSlice.actions.setComptPositions;
var configSlice$1 = configSlice.reducer;

var store = toolkit.configureStore({
  reducer: {
    config: configSlice$1
  }
});

var InternalNavBar = function InternalNavBar(props) {
  var _useState = React.useState(0),
      scrollY = _useState[0],
      setScrollY = _useState[1];

  var globalState = reactRedux.useSelector(function (state) {
    return state.config.cmpPositions;
  });
  document.addEventListener('scroll', function (e) {
    setScrollY(window.scrollY);
  });
  var navLinks = props.items.map(function (i) {
    try {
      return /*#__PURE__*/React__default.createElement(Nav.Link, {
        key: i.id,
        href: '#' + i.id,
        active: scrollY >= globalState[i.id][0] && scrollY < globalState[i.id][1]
      }, i.item);
    } catch (e) {
      console.log('items can not be calculated yet...waiting on positions');
      return [];
    }
  });
  return /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement(Navbar, {
    bg: props.bg,
    variant: props.variant,
    fixed: "top"
  }, /*#__PURE__*/React__default.createElement(Container, null, /*#__PURE__*/React__default.createElement(Navbar.Brand, {
    href: "#home"
  }, props.img), /*#__PURE__*/React__default.createElement(Nav, {
    className: ""
  }, navLinks))), props.children);
};

var recalculate = function recalculate(state, id, top, hight) {
  try {
    if (state.hasOwnProperty(id)) {
      return state[id][0] !== top || state[id][1] !== hight;
    } else {
      return true;
    }
  } catch (e) {
    return false;
  }
};

var ItemScrollSpy = function ItemScrollSpy(props) {
  var dispatch = reactRedux.useDispatch();
  var globalState = reactRedux.useSelector(function (state) {
    return state.config.cmpPositions;
  });
  React.useEffect(function () {
    var paddingTop = props.paddingTop ? props.paddingTop : 0;
    var paddingBottom = props.paddingBottom ? props.paddingBottom : 0;
    var hight = document.querySelector('#' + props.scrollSpyId).offsetHeight;
    var top = document.querySelector('#' + props.scrollSpyId).offsetTop;
    var updatePositions = recalculate(globalState, props.scrollSpyId, top + paddingTop, top + hight + paddingBottom);

    if (updatePositions) {
      var _setComptPositions;

      dispatch(setComptPositions((_setComptPositions = {}, _setComptPositions[props.scrollSpyId] = [top + paddingTop, top + hight + paddingBottom], _setComptPositions)));
    }
  });
  return /*#__PURE__*/React__default.createElement("div", {
    id: props.scrollSpyId,
    style: {
      height: 'auto'
    }
  }, props.children);
};

var NavBarScrollSpy = function NavBarScrollSpy(props) {
  return /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement(reactRedux.Provider, {
    store: store
  }, /*#__PURE__*/React__default.createElement(InternalNavBar, props, props.children)));
};

exports.React = React__default;
exports.ItemScrollSpy = ItemScrollSpy;
exports.NavBarScrollSpy = NavBarScrollSpy;
//# sourceMappingURL=index.js.map
